<id>
Member Moods for YaBB 2.7.00
</id>

<version>
0.4
</version>

<mod info>
Description
-----------
Allows Members to select their Mood

Installation
------------
1) Modify YaBB files using YaBMod.

Version History
---------------
1.0 - First release by Derek Barnstorm - 5th August 2008
1.1 - Made new images, aligned text and image better, added more moods and added preview image in User CP - 1st October 2008
1.2 - Updated for YaBB 2.3 - 14th October 2008
1.3 - Updated for YaBB 2.3.1 - 4th January 2009
1.4 - Updated for YaBB 2.4 and added ability to change mood by clicking on the image (Martin_W) - 4th May 2009
1.5 - Added to Member List and fixed issue with some users receiving Form Spoofing message - 6th July 2009
1.6 - Updated for YaBB 2.5 - 13th January 2011
1.7 - Updated for YaBB 2.6.0 by Dandello - 13 July, 2014
1.7a - fixed typos.
1.8 - Updated for YaBB 2.6.1 by Dandello - 6 Sept, 2014
2.1 - Updated for YaBB 2.6.1 by Dandello (new css file) 21 Oct, 2014
2.6.11 v0.1 - Updated for YaBB 2.6.1 Dec 31, 2014
0.2 - bug fixes - Jan 21, 2014
0.3 (2.7.00) - Updated for YaBB 2.7.00 Mar 21, 2016
0.3 (2.7.00 strict) - Updated for YaBB 2.7.00 Jan 12, 2017
0.4 (2.7.00 strict) - Updated for YaBB 2.7.00 Jan 3, 2018
</mod info>

<author>
Derek Barnstorm and Martin_W
</author>

<homepage>
http://www.yabbforumsoftware,com
</homepage>

<edit file>
Admin/ModList.pm
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    my $mod_mood = q~Member Moods|Derek Barnstorm and Martin_W, updated for 2.7.00 by Dandello|Allows Members to select their Mood|0.4|Jan 3, 2018~;
    push @installed_mods, $mod_mood;
</add before>

<edit file>
Admin/NewSettings.pm
</edit file>

<search for>
if (@newsettingspmmods) {
</search for>

<add before>
push @newsettingspmmods, 'Member Moods';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ($showmoodimage, $showmood, $showmoodml, $showmoodicon, $allowselectmood );
</add before>

<search for>
1;
EOF
</search for>

<add before>
\$showmoodimage = $showmoodimage;           # Set to 1 to display each members mood in the message view
\$showmood = $showmood;                     # Set to 1 to display each members mood in profile
\$showmoodml = $showmoodml;                 # Set to 1 to display each members mood in the member list
\$showmoodicon = $showmoodicon;                 # Set to 1 to display each members mood as an icon only
\$allowselectmood = $allowselectmood;       # Set to 1 to allow members to select mood
</add before>

<edit file>
Admin/Settings_Main.pm
</edit file>

<search for>
if (@settings_mainpmmods) {
</search for>

<add before>
push @settings_mainpmmods, 'Member Moods';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our (
    $showmoodimage, $showmood,        $showmoodml,
    $showmoodicon,  $allowselectmood, %mood_txt
);
$showmoodimage   ||= q{};
$showmood        ||= q{};
$showmoodml      ||= q{};
$showmoodicon    ||= q{};
$allowselectmood ||= q{};
</add before>

<search for>
load_language('Register');
</search for>

<add after>
load_language('Mods/Mood');
</add after>

<search for>
                name     => 'showgenderimage',
                validate => 'boolean',
            },
</search for>

<add after>
            {
                description =>
                  qq~<label for="showmoodimage">$mood_txt{'04'}</label>~,
                input_html =>
qq~<input type="checkbox" name="showmoodimage" id="showmoodimage" value="1"${ischecked($showmoodimage)} />~,
                name     => 'showmoodimage',
                validate => 'boolean',
            },
            {
                description =>
                  qq~<label for="showmood">$mood_txt{'05'}</label>~,
                input_html =>
qq~<input type="checkbox" name="showmood" id="showmood" value="1"${ischecked($showmood)} />~,
                name     => 'showmood',
                validate => 'boolean',
            },
            {
                description =>
                  qq~<label for="showmoodml">$mood_txt{'05a'}</label>~,
                input_html =>
qq~<input type="checkbox" name="showmoodml" id="showmoodml" value="1"${ischecked($showmoodml)} />~,
                name     => 'showmoodml',
                validate => 'boolean',
            },
            {
                description =>
                  qq~<label for="showmoodicon">$mood_txt{'05b'}</label>~,
                input_html =>
qq~<input type="checkbox" name="showmoodicon" id="showmoodicon" value="1"${ischecked($showmoodicon)} />~,
                name     => 'showmoodicon',
                validate => 'boolean',
            },
</add after>

<search for>
            {
                description =>
                  qq~<label for="allowpics">$admin_txt{'746'}</label>~,
</search for>

<add before>
            {
                description =>
                  qq~<label for="allowselectmood">$mood_txt{'03'}</label>~,
                input_html =>
qq~<input type="checkbox" name="allowselectmood" id="allowselectmood" value="1"${ischecked($allowselectmood)} />~,
                name     => 'allowselectmood',
                validate => 'boolean',
            },
</add before>

<edit file>
Sources/Display.pm
</edit file>

<search for>
if (@displaypmmods) {
</search for>

<add before>
push @displaypmmods, 'Member Moods';
</add before>

<search for>
## Mod Hook Outbox ##
</search for>

<add before>
        ${ $uid . $musername }{'mood'} ||= q{};
        $outblock =~ s/\Q{yabb mood}\E/${ $uid . $musername }{'mood'}/gxsm;
</add before>

<edit file>
Sources/Load.pm
</edit file>

<search for>
if (@loadpmmods) {
</search for>

<add before>
push @loadpmmods, 'Member Moods';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ( $showmoodimage, $allowselectmood, $showmoodicon );
</add before>

<search for>
    load_miniuser($usr);

    $yy_udloaded{$usr} = 1;
</search for>

<add before>
    my ($mymood) = get_mood($usr);
    {
        no strict qw(refs);
        ${ $uid . $usr }{'mood'} = $mymood;
    }

</add before>

<search for>
1;
</search for>

<add before>
sub get_mood {
    my ($usr) = @_;
    my $mymood = q{};
    no strict qw(refs);
    if ($showmoodimage && $allowselectmood && ${ $uid . $usr }{'mood'} && ${ $uid . $usr }{'mood'} ne 'NoMood') {
        our ( %moodimg, %moodlist, $moodext, %mood_txt );
        load_language('Mods/Mood');
        my $moodtxt = ${ $uid . $usr }{'mood'};
        $mymood = $moodtxt;

        my $moodicon = $moodimg{$moodtxt};
        if ( $showmoodicon ) {
            $moodicon = qq~<img src="$modimgurl/Mood/$moodtxt$moodext" title="$moodlist{$moodtxt}" />~;
        }
        if ($username eq $usr && $mymood ) {
            my $moodlinkjavascript = qq~
            <script type="text/javascript">
            function Moodlink() {
            window.open('$scripturl?action=changemood', '', 'menubar=no,toolbar=no,top=50,left=50,scrollbars=yes,resizable=yes,width=450,height=300');
            }
            </script>~;
            $mymood = qq~<div style="padding-top:5px"><span style="vertical-align: middle;">$mood_txt{'01'}:</span> $moodlinkjavascript<a href="javascript:void(0);" onclick="Moodlink()" style="color:#000">$moodicon</a></div>~;
        }
        elsif ($username ne $usr && $mymood ) {
            $mymood = qq~<div style="padding-top:5px"><span style="margin-top:1em"><span style="vertical-align: top;">$mood_txt{'01'}:</span> $moodicon</span></div>~;
        }
        else { $mymood = q{}; }
    }
    else {
        $mymood = q{};
    }
    return $mymood;
}

</add before>

<edit file>
Sources/Memberlist.pm
</edit file>

<search for>
if (@memberlistpmmods) {
</search for>

<add before>
push @memberlistpmmods, 'Member Moods';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ( $showmoodimage, $showmood, $showmoodml, $showmoodicon, $allowselectmood );
</add before>

<search for>
        $additional_tds ||= q{};
</search for>

<add before>
        my $mood =  getml_mood($user);

</add before>

<search for>
        $yymain =~ s/\Q{yabb userlink}\E/$link{$user}/xsm;
</search for>

<replace>
        $yymain =~ s/\Q{yabb userlink}\E/$link{$user}$mood/xsm;
</replace>

<search for>
1;
</search for>

<add before>
sub getml_mood {
    my ($usr) = @_;
    my $mood = q{};
    no strict qw(refs);
    if (   $showmoodml
        && $allowselectmood
        && ${ $uid . $usr }{'mood'}
        && ${ $uid . $usr }{'mood'} ne 'NoMood' )
    {
        our ( %moodimg, %moodlist, %mood_txt, $moodext );
        load_language('Mods/Mood');
        my $moodtxt  = ${ $uid . $usr }{'mood'};
        my $moodicon = $moodimg{$moodtxt};
        if ($showmoodicon) {
            $moodicon =
qq~<img src="$modimgurl/Mood/$moodtxt$moodext" title="$moodlist{$moodtxt}" />~;
        }
        my $moodlinkjavascript = q{};
        if ( $username eq $usr ) {
            $moodlinkjavascript = qq~
            <script type="text/javascript">
            function Moodlink() {
            window.open('$scripturl?action=changemood', '', 'menubar=no,toolbar=no,top=50,left=50,scrollbars=yes,resizable=yes,width=450,height=300');
            }
            </script>~;
            $mood =
              ${ $uid . $usr }{'mood'}
              ? qq~<div style="padding-top:5px"><span class="small" style="vertical-align: top;">$mood_txt{'01'}:</span> $moodlinkjavascript<a href="javascript:void(0);" onclick="Moodlink()" style="color:#000">$moodicon</a></div>~
              : q{};
        }
        elsif ( $username ne $usr ) {
            $mood =
              ${ $uid . $usr }{'mood'}
              ? qq~<div style="padding-top:5px"><span class="small" style="vertical-align: top;">$mood_txt{'01'}:</span> $moodicon</div>~
              : q{};
        }
    }
    else { $mood = q{}; }
    return $mood;
}

</add before>

<edit file>
Sources/MyCenter.pm
</edit file>

<search for>
if (@mycenterpmmods) {
</search for>

<add before>
push @mycenterpmmods, 'Member Moods';
</add before>

<search for>
## Mod Hook myprofileblock ##
</search for>

<add before>
        $myprofileblock =~ s/\Q{yabb mood}\E/${$uid.$username}{'mood'}/gxsm;
</add before>

<edit file>
Sources/Profile.pm
</edit file>

<search for>
if (@profilepmmods) {
</search for>

<add before>
push @profilepmmods, 'Member Moods';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ( $showmoodimage, $showmood, $showmoodml, $showmoodicon, $allowselectmood,
    $myprofile_mood, $mymoodcol1 );
</add before>

<search for>
## Mod Hook showProfile1 ##
</search for>

<add before>
    my $sel_mood = get_sel_mood($user);
    $show_profile =~ s/\Q{yabb my_mood}\E/$sel_mood/xsm;
</add before>

<search for>
        user_account( $user, 'update' );
</search for>

<add before>
        $member{'mood'} = to_html( $member{'mood'} );
        ${ $uid . $user }{'mood'} = $member{'mood'};

</add before>

<search for>
    # End empty field checking
</search for>

<add before>
    my $row_mood   = getpr_mood($user);

</add before>

<search for>
## Mod Hook showProfile2 ##
</search for>

<add before>
    $show_profile =~ s/\Q{yabb mood}\E/$row_mood/xsm;
</add before>

<search for>
1;
</search for>

<add before>
sub get_sel_mood {
    my ($usr) = @_;
    my $sel_mood = q{};
    if ($allowselectmood) {
        our ( %moodlist, $moodext, %mood_txt, );
        load_language('Mods/Mood');
        my $nomood = q{};
        if ( !${ $uid . $usr }{'mood'} ) { $nomood = 'NoMood'; }
        else                             { $nomood = ${ $uid . $usr }{'mood'}; }
        my @moodlist =
          sort { lc $moodlist{$a} cmp lc $moodlist{$b} } keys %moodlist;
        my $my_mood_opt = q{};
        foreach my $i (@moodlist) {
            my $sel = q{};
            if ( $nomood eq $i ) { $sel = ' selected="selected" '; }
            $my_mood_opt .=
              qq~        <option value="$i"$sel>$moodlist{$i}</option>\n~;
        }

        my $moodclass = qq~class='mood bold $nomood'~;
        if ( $nomood eq 'NoMood' ) {
            $moodclass = q~class='bold'~;
        }
        my $moodicon =
qq~<span id="moodspan" $moodclass><img src='$modimgurl/Mood/$nomood$moodext' id='moodicons' alt='' /> <span id="moodtxt">$moodlist{$nomood}</span> </span>~;
        if ($showmoodicon) {
            $moodicon =
qq~<img src='$modimgurl/Mood/$nomood$moodext' id='moodicons' title='$moodlist{$nomood}' />~;
        }

        $sel_mood = $myprofile_mood;
        $sel_mood =~ s/\Q{yabb mood01}\E/$mood_txt{'01'}/xsm;
        $sel_mood =~ s/\Q{yabb lang}\E/${ $uid . $user}{'language'}/gxsm;
        $sel_mood =~ s/\Q{yabb nomood}\E/$nomood/gxsm;
        $sel_mood =~ s/\Q{yabb moodext}\E/$moodext/gxsm;
        $sel_mood =~ s/\Q{yabb my_mood_opt}\E/$my_mood_opt/gxsm;
        $sel_mood =~ s/\Q{yabb showmoodicon}\E/$moodicon/gxsm;
        $sel_mood =~ s/\Q{yabb showmoodcol1}\E/$mymoodcol1/gxsm;
    }
    return $sel_mood;
}

sub getpr_mood {
    my ($usr) = @_;
    my $row_mood = q{};
    if (   $showmood
        && $allowselectmood
        && ${ $uid . $usr }{'mood'}
        && ${ $uid . $usr }{'mood'} ne 'NoMood' )
    {
        our ( %moodlist, $moodext, %mood_txt, %moodimg );
        load_language('Mods/Mood');
        my $moodtxt  = ${ $uid . $usr }{'mood'};
        my $moodicon = $moodimg{$moodtxt};
        if ($showmoodicon) {
            $moodicon =
qq~<img src="$modimgurl/Mood/$moodtxt$moodext" title="$moodlist{$moodtxt}" />~;
        }
        my $moodlinkjavascript = q{};
        if ( $username eq $usr ) {
            $moodlinkjavascript = qq~
            <script type="text/javascript">
            function Moodlink() {
            window.open('$scripturl?action=changemood', '', 'menubar=no,toolbar=no,top=50,left=50,scrollbars=yes,resizable=yes,width=450,height=300');
            }
            </script>~;
            $row_mood .=
qq~<div style="padding-top:5px"><span style="vertical-align: top;">$mood_txt{'01'}:</span> $moodlinkjavascript<a href="javascript:void(0);" onclick="Moodlink()" style="color:#000">$moodicon</a></div>~;
        }
        else {
            $row_mood .=
qq~<div style="padding-top:5px"><span class="small" style="vertical-align: top;">$mood_txt{'01'}:</span> $moodicon</div>~;
        }
    }
    return $row_mood;
}

</add before>

<edit file>
Sources/Subs.pm
</edit file>

<search for>
if (@subspmmods) {
</search for>

<add before>
push @subspmmods, 'Member Moods';
</add before>

<search for>
## our Mod Hook ##
</search for>

<add before>
our ($showmoodimage, $showmood, $showmoodml, $showmoodicon, $allowselectmood);
</add before>

<search for>
    $yystyle =
qq~<link rel="stylesheet" href="$yyhtml_root/Templates/Forum/$usestyle.css" type="text/css" />\n~;
</search for>

<add after>
    if ( $action eq 'myprofile' || $action eq 'mycenter' || ( $showmoodimage && $INFO{'num'} ) || ( $showmoodml && $action eq 'ml' ) || ( $showmood && ( $action eq 'viewprofile' || $action eq 'myviewprofile' || $action eq 'profile' ) ) ) {
        $yystyle .= qq~<link rel="stylesheet" href="$yyhtml_root/Templates/Forum/mood.css" type="text/css" />\n~;
    }
</add after>

<edit file>
Sources/SubList.pm
</edit file>

<search for>
if (@sublistpmmods) {
</search for>

<add before>
push @sublistpmmods, 'Member Moods';
</add before>

<search for>
1;
</search for>

<add before>
$director{'changemood'} = 'Mods/ChangeMood.pm&changemood';
$director{'changemood2'} = 'Mods/ChangeMood.pm&changemood2';
</add before>

<edit file>
Sources/System.pm
</edit file>

<search for>
if (@systempmmods) {
</search for>

<add before>
push @systempmmods, 'Member Moods';
</add before>

<search for>
    ## Mod hook ##
</search for>

<add before>
    push @var_tags, 'mood';
</add before>

<edit file>
Templates/default/Display.template
</edit file>

<search for>
if (@defaultdisplaymods) {
</search for>

<add before>
push @defaultdisplaymods, 'Member Moods';
</add before>

<search for>
                        {yabb gender}
</search for>

<add after>
                        {yabb mood}
</add after>

<edit file>
Templates/default/MyCenter.template
</edit file>

<search for>
if (@defaultmycentermods) {
</search for>

<add before>
push @defaultmycentermods, 'Member Moods';
</add before>

<search for>
        {yabb gender}
</search for>

<add after>
        {yabb mood}
</add after>

<edit file>
Templates/default/MyProfile.template
</edit file>

<search for>
if (@defaultmyprofilemods) {
</search for>

<add before>
push @defaultmyprofilemods, 'Member Moods';
</add before>

<search for>
            </select>{yabb genderField}
        </td>
    </tr>
</search for>

<add after>
{yabb my_mood}
</add after>

<search for>
{yabb my_online}
            <br />
</search for>

<add after>
{yabb mood}
</add after>

<search for>
1;
</search for>

<add before>
$myprofile_mood = qq~<tr class="windowbg">
    <td><label for="mood"><b>{yabb mood01}: </b></label></td>
    <td>
        <script type="text/javascript">
            function showmoodimage() {
                if (!document.images) return;
                var mymood = mood.options[mood.selectedIndex].value;
                var mymoodt = mymoodcol1[ mymood ][ "mtitle" ] ;
                document.images.moodicons.src = "$modimgurl/Mood/" + mymood + "{yabb moodext}";
                document.images.moodicons.title = mymoodt;~;
    if (!$showmoodicon) {
        $myprofile_mood .= q~
                moodtxt.textContent = mymoodt;
             if ( mymood == "NoMood" ) {
                moodspan.setAttribute("class", "bold");
            }
            else {
                moodspan.setAttribute("class", "mood bold " + mymood);
            }~;
    }
$myprofile_mood .= q~            }
         </script>
   <span style="vertical-align: middle;">
    <select name="mood" id="mood" size="1" onchange="showmoodimage();">
{yabb my_mood_opt}
   </select>
   </span>&nbsp;&nbsp; {yabb showmoodicon}
   {yabb showmoodcol1}
   </td>
 </tr>~;
 
</add before>
